## Keyboard Handling

Keyboard Handling

## Functions

GdkKeymap * | gdk_keymap_get_default ()
GdkKeymap * | gdk_keymap_get_for_display ()
guint | gdk_keymap_lookup_key ()
gboolean | gdk_keymap_translate_keyboard_state ()
gboolean | gdk_keymap_get_entries_for_keyval ()
gboolean | gdk_keymap_get_entries_for_keycode ()
PangoDirection | gdk_keymap_get_direction ()
gboolean | gdk_keymap_have_bidi_layouts ()
gboolean | gdk_keymap_get_caps_lock_state ()
void | gdk_keymap_add_virtual_modifiers ()
gboolean | gdk_keymap_map_virtual_modifiers ()
gchar * | gdk_keyval_name ()
guint | gdk_keyval_from_name ()
void | gdk_keyval_convert_case ()
guint | gdk_keyval_to_upper ()
guint | gdk_keyval_to_lower ()
gboolean | gdk_keyval_is_upper ()
gboolean | gdk_keyval_is_lower ()
guint32 | gdk_keyval_to_unicode ()
guint | gdk_unicode_to_keyval ()

## Signals

void | direction-changed | Run Last
void | keys-changed | Run Last
void | state-changed | Run Last

## Types and Values

struct | GdkKeymap
struct | GdkKeymapKey

## Object Hierarchy

        GObject
        ╰── GdkKeymap

## Includes

    #include <gdk/gdk.h>

## Description

## Functions

### gdk_keymap_get_default ()

    GdkKeymap *
    gdk_keymap_get_default (void);

Returns the GdkKeymap attached to the default display.

#### Parameters

returns | the GdkKeymap attached to the default display. |

### gdk_keymap_get_for_display ()

    GdkKeymap *
    gdk_keymap_get_for_display (GdkDisplay *display);

Returns the GdkKeymap attached to `display` .

#### Parameters

display | the GdkDisplay. |
returns | the GdkKeymap attached to `display` . |

Since: 2.2

### gdk_keymap_lookup_key ()

    guint
    gdk_keymap_lookup_key (GdkKeymap *keymap,
                           const GdkKeymapKey *key);

Looks up the keyval mapped to a keycode/group/level triplet. If no keyval is bound to `key` , returns 0. For normal user input, you want to use `gdk_keymap_translate_keyboard_state()` instead of this function, since the effective group/level may not be the same as the current keyboard state.

Note that passing `NULL` for `keymap` is deprecated and will stop to work in GTK+ 3.0. Use `gdk_keymap_get_for_display()` instead.

#### Parameters

keymap | a GdkKeymap or `NULL` to use the default keymap |
key | a GdkKeymapKey with keycode, group, and level initialized |

#### Returns

a keyval, or 0 if none was mapped to the given `key`

### gdk_keymap_translate_keyboard_state ()

    gboolean
    gdk_keymap_translate_keyboard_state (GdkKeymap *keymap,
                                         guint hardware_keycode,
                                         GdkModifierType state,
                                         gint group,
                                         guint *keyval,
                                         gint *effective_group,
                                         gint *level,
                                         GdkModifierType *consumed_modifiers);

Translates the contents of a GdkEventKey into a keyval, effective group, and level. Modifiers that affected the translation and are thus unavailable for application use are returned in `consumed_modifiers` . See ??? for an explanation of groups and levels. The `effective_group` is the group that was actually used for the translation; some keys such as Enter are not affected by the active keyboard group. The `level` is derived from `state` . For convenience, GdkEventKey already contains the translated keyval, so this function isn't as useful as you might think.

`consumed_modifiers` gives modifiers that should be masked out from `state` when comparing this key press to a hot key. For instance, on a US keyboard, the `plus` symbol is shifted, so when comparing a key press to a `<Control>plus` accelerator <Shift> should be masked out.

    1
    2
    3
    4
    5
    6
    7
    8

    /* We want to ignore irrelevant modifiers like ScrollLock */
    #define ALL_ACCELS_MASK (GDK_CONTROL_MASK | GDK_SHIFT_MASK | GDK_MOD1_MASK)
    gdk_keymap_translate_keyboard_state (keymap, event->hardware_keycode,
                                         event->state, event->group,
                                         &keyval, NULL, NULL, &consumed);
    if (keyval == GDK_PLUS &&
        (event->state & ~consumed & ALL_ACCELS_MASK) == GDK_CONTROL_MASK)
      /* Control was pressed */

An older interpretation `consumed_modifiers` was that it contained all modifiers that might affect the translation of the key; this allowed accelerators to be stored with irrelevant consumed modifiers, by doing:

    1
    2
    3
    4

    /* XXX Don't do this XXX */
    if (keyval == accel_keyval &&
        (event->state & ~consumed & ALL_ACCELS_MASK) == (accel_mods & ~consumed))
      /* Accelerator was pressed */

However, this did not work if multi-modifier combinations were used in the keymap, since, for instance, `<Control>` would be masked out even if only `<Control><Alt>` was used in the keymap. To support this usage as well as well as possible, all single modifier combinations that could affect the key for any combination of modifiers will be returned in `consumed_modifiers`; multi-modifier combinations are returned only when actually found in `state`. When you store accelerators, you should always store them with consumed modifiers removed. Store `<Control>plus`, not `<Control><Shift>plus`,

Note that passing `NULL` for `keymap` is deprecated and will stop to work in GTK+ 3.0. Use `gdk_keymap_get_for_display()` instead.

#### Parameters

keymap | a GdkKeymap, or `NULL` to use the default. | [allow-none]
hardware_keycode | a keycode |
state | a modifier state |
group | active keyboard group |
keyval | return location for keyval, or `NULL`. | [out][allow-none]
effective_group | return location for effective group, or `NULL`. | [out][allow-none]
level | return location for level, or `NULL`. | [out][allow-none]
consumed_modifiers | return location for modifiers that were used to determine the group or level, or `NULL`. | [out][allow-none]

#### Returns

`TRUE` if there was a keyval bound to the keycode/state/group

### gdk_keymap_get_entries_for_keyval ()

    gboolean
    gdk_keymap_get_entries_for_keyval (GdkKeymap *keymap,
                                       guint keyval,
                                       GdkKeymapKey **keys,
                                       gint *n_keys);

Obtains a list of keycode/group/level combinations that will generate `keyval` . Groups and levels are two kinds of keyboard mode; in general, the level determines whether the top or bottom symbol on a key is used, and the group determines whether the left or right symbol is used. On US keyboards, the shift key changes the keyboard level, and there are no groups. A group switch key might convert a keyboard between Hebrew to English modes, for example. GdkEventKey contains a `group` field that indicates the active keyboard group. The level is computed from the modifier mask. The returned array should be freed with `g_free()`.

Note that passing `NULL` for `keymap` is deprecated and will stop to work in GTK+ 3.0. Use `gdk_keymap_get_for_display()` instead.

#### Parameters

keymap | a GdkKeymap, or `NULL` to use the default keymap. | [allow-none]
keyval | a keyval, such as `GDK_a`, `GDK_Up`, `GDK_Return`, etc. |
keys | return location for an array of GdkKeymapKey. | [out]
n_keys | return location for number of elements in returned array. | [out]

#### Returns

`TRUE` if keys were found and returned

### gdk_keymap_get_entries_for_keycode ()

    gboolean
    gdk_keymap_get_entries_for_keycode (GdkKeymap *keymap,
                                        guint hardware_keycode,
                                        GdkKeymapKey **keys,
                                        guint **keyvals,
                                        gint *n_entries);

Returns the keyvals bound to `hardware_keycode` . The Nth GdkKeymapKey in `keys` is bound to the Nth keyval in `keyvals` . Free the returned arrays with `g_free()`. When a keycode is pressed by the user, the keyval from this list of entries is selected by considering the effective keyboard group and level. See `gdk_keymap_translate_keyboard_state()`.

Note that passing `NULL` for `keymap` is deprecated and will stop to work in GTK+ 3.0. Use `gdk_keymap_get_for_display()` instead.

#### Parameters

keymap | a GdkKeymap or `NULL` to use the default keymap. | [allow-none]
hardware_keycode | a keycode |
keys | return location for array of GdkKeymapKey, or `NULL`. | [out]
keyvals | return location for array of keyvals, or `NULL`. | [out]
n_entries | length of `keys` and `keyvals` |

#### Returns

`TRUE` if there were any entries

### gdk_keymap_get_direction ()

    PangoDirection
    gdk_keymap_get_direction (GdkKeymap *keymap);

Returns the direction of effective layout of the keymap.

Note that passing `NULL` for `keymap` is deprecated and will stop to work in GTK+ 3.0. Use `gdk_keymap_get_for_display()` instead.

#### Parameters

keymap | a GdkKeymap or `NULL` to use the default keymap |

#### Returns

`PANGO_DIRECTION_LTR` or `PANGO_DIRECTION_RTL` if it can determine the direction. `PANGO_DIRECTION_NEUTRAL` otherwise.

### gdk_keymap_have_bidi_layouts ()

    gboolean
    gdk_keymap_have_bidi_layouts (GdkKeymap *keymap);

Determines if keyboard layouts for both right-to-left and left-to-right languages are in use.

Note that passing `NULL` for `keymap` is deprecated and will stop to work in GTK+ 3.0. Use `gdk_keymap_get_for_display()` instead.

#### Parameters

keymap | a GdkKeymap or `NULL` to use the default keymap |

#### Returns

`TRUE` if there are layouts in both directions, `FALSE` otherwise

Since: 2.12

### gdk_keymap_get_caps_lock_state ()

    gboolean
    gdk_keymap_get_caps_lock_state (GdkKeymap *keymap);

Returns whether the Caps Lock modifer is locked.

#### Parameters

keymap | a GdkKeymap |

#### Returns

`TRUE` if Caps Lock is on

Since: 2.16

### gdk_keymap_add_virtual_modifiers ()

    void
    gdk_keymap_add_virtual_modifiers (GdkKeymap *keymap,
                                      GdkModifierType *state);

Adds virtual modifiers (i.e. Super, Hyper and Meta) which correspond to the real modifiers (i.e Mod2, Mod3, ...) in `modifiers` . are set in `state` to their non-virtual counterparts (i.e. Mod2, Mod3,...) and set the corresponding bits in `state` .

GDK already does this before delivering key events, but for compatibility reasons, it only sets the first virtual modifier it finds, whereas this function sets all matching virtual modifiers.

This function is useful when matching key events against accelerators.

#### Parameters

keymap | a GdkKeymap |
state | pointer to the modifier mask to change |

Since: 2.20

### gdk_keymap_map_virtual_modifiers ()

    gboolean
    gdk_keymap_map_virtual_modifiers (GdkKeymap *keymap,
                                      GdkModifierType *state);

Maps the virtual modifiers (i.e. Super, Hyper and Meta) which are set in `state` to their non-virtual counterparts (i.e. Mod2, Mod3,...) and set the corresponding bits in `state` .

This function is useful when matching key events against accelerators.

#### Parameters

keymap | a GdkKeymap |
state | pointer to the modifier state to map |

#### Returns

`TRUE` if no virtual modifiers were mapped to the same non-virtual modifier. Note that `FALSE` is also returned if a virtual modifier is mapped to a non-virtual modifier that was already set in `state` .

Since: 2.20

### gdk_keyval_name ()

    gchar *
    gdk_keyval_name (guint keyval);

Converts a key value into a symbolic name.

The names are the same as those in the `<gdk/gdkkeysyms.h>` header file but without the leading "GDK_KEY_".

#### Parameters

keyval | a key value |

#### Returns

a string containing the name of the key, or `NULL` if `keyval` is not a valid key. The string should not be modified.

[transfer none]

### gdk_keyval_from_name ()

    guint
    gdk_keyval_from_name (const gchar *keyval_name);

Converts a key name to a key value.

The names are the same as those in the `<gdk/gdkkeysyms.h>` header file but without the leading "GDK_KEY_".

#### Parameters

keyval_name | a key name |

#### Returns

the corresponding key value, or `GDK_KEY_VoidSymbol` if the key name is not a valid key

### gdk_keyval_convert_case ()

    void
    gdk_keyval_convert_case (guint symbol,
                             guint *lower,
                             guint *upper);

Obtains the upper- and lower-case versions of the keyval `symbol` . Examples of keyvals are GDK_a, GDK_Enter, GDK_F1, etc.

#### Parameters

symbol | a keyval |
lower | return location for lowercase version of `symbol` . | [out]
upper | return location for uppercase version of `symbol` . | [out]

### gdk_keyval_to_upper ()

    guint
    gdk_keyval_to_upper (guint keyval);

### gdk_keyval_to_lower ()

    guint
    gdk_keyval_to_lower (guint keyval);

### gdk_keyval_is_upper ()

    gboolean
    gdk_keyval_is_upper (guint keyval);

### gdk_keyval_is_lower ()

    gboolean
    gdk_keyval_is_lower (guint keyval);

### gdk_keyval_to_unicode ()

    guint32
    gdk_keyval_to_unicode (guint keyval);

Convert from a GDK key symbol to the corresponding ISO10646 (Unicode) character.

#### Parameters

keyval | a GDK key symbol |

#### Returns

the corresponding unicode character, or 0 if there is no corresponding character.

### gdk_unicode_to_keyval ()

    guint
    gdk_unicode_to_keyval (guint32 wc);

Convert from a ISO10646 character to a key symbol.

#### Parameters

wc | a ISO10646 encoded character |

#### Returns

the corresponding GDK key symbol, if one exists. or, if there is no corresponding symbol, wc | 0x01000000

## Types and Values

### struct GdkKeymap

    struct GdkKeymap;

### struct GdkKeymapKey

    struct GdkKeymapKey {
      guint keycode;
      gint  group;
      gint  level;
    };

## Signal Details

### The `“direction-changed”` signal

    void
    user_function (GdkKeymap *keymap,
                   gpointer   user_data)

The ::direction-changed signal gets emitted when the direction of the keymap changes.

#### Parameters

keymap | the object on which the signal is emitted |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 2.0

### The `“keys-changed”` signal

    void
    user_function (GdkKeymap *keymap,
                   gpointer   user_data)

The ::keys-changed signal is emitted when the mapping represented by `keymap` changes.

#### Parameters

keymap | the object on which the signal is emitted |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 2.2

### The `“state-changed”` signal

    void
    user_function (GdkKeymap *keymap,
                   gpointer   user_data)

The ::state-changed signal is emitted when the state of the keyboard changes, e.g when Caps Lock is turned on or off. See `gdk_keymap_get_caps_lock_state()`.

#### Parameters

keymap | the object on which the signal is emitted |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 2.16